//NameTag by DarkyBenji
--Feature inspired from v2, recreated for v1

--Thanks to Tyron for the Colorskin
local colLookup = {[SKINCOLOR_WHITE] = "\x80",	[SKINCOLOR_SILVER] = "\x80",	[SKINCOLOR_SLATE] = "\x80",		[SKINCOLOR_ULTRAVIOLET] = "\x81",	[SKINCOLOR_PURPLE] = "\x81",	[SKINCOLOR_FUCHSIA] = "\x81",		[SKINCOLOR_POPCORN] = "\x82",	[SKINCOLOR_QUARRY] = "\x82",	[SKINCOLOR_YELLOW] = "\x82",	[SKINCOLOR_MUSTARD] = "\x82",	[SKINCOLOR_CROCODILE] = "\x82",	[SKINCOLOR_OLIVE] = "\x82",		[SKINCOLOR_LIME] = "\x83",	[SKINCOLOR_HANDHELD] = "\x83",	[SKINCOLOR_MOSS] = "\x83",	[SKINCOLOR_CAMOUFLAGE] = "\x83",	[SKINCOLOR_ROBOHOOD] = "\x83",	[SKINCOLOR_MINT] = "\x83",	[SKINCOLOR_GREEN] = "\x83",	[SKINCOLOR_PINETREE] = "\x83",	[SKINCOLOR_ALGAE] = "\x83",	[SKINCOLOR_PLAGUE] = "\x83",	[SKINCOLOR_EMERALD] = "\x83",	[SKINCOLOR_SWAMP] = "\x83",	[SKINCOLOR_DREAM] = "\x83",		[SKINCOLOR_PERIWINKLE] = "\x84",	[SKINCOLOR_BLUE] = "\x84",	[SKINCOLOR_BLUEBERRY] = "\x84",	[SKINCOLOR_NOVA] = "\x84",		[SKINCOLOR_CINNAMON] = "\x85",	[SKINCOLOR_RUBY] = "\x85",	[SKINCOLOR_RASPBERRY] = "\x85",	[SKINCOLOR_CHERRY] = "\x85",	[SKINCOLOR_RED] = "\x85",	[SKINCOLOR_CRIMSON] = "\x85",	[SKINCOLOR_MAROON] = "\x85",	[SKINCOLOR_FLAME] = "\x85",	[SKINCOLOR_SCARLET] = "\x85",	[SKINCOLOR_KETCHUP] = "\x85",		[SKINCOLOR_GREY] = "\x86",	[SKINCOLOR_NICKEL] = "\x86",	[SKINCOLOR_BLACK] = "\x86",	[SKINCOLOR_SKUNK] = "\x86",	[SKINCOLOR_JET] = "\x86",		[SKINCOLOR_DAWN] = "\x87",	[SKINCOLOR_SUNSET] = "\x87",	[SKINCOLOR_CREAMSICLE] = "\x87",	[SKINCOLOR_ORANGE] = "\x87",	[SKINCOLOR_PUMPKIN] = "\x87",	[SKINCOLOR_ROSEWOOD] = "\x87",	[SKINCOLOR_BURGUNDY] = "\x87",	[SKINCOLOR_TANGERINE] = "\x87",		[SKINCOLOR_CARIBBEAN] = "\x88",	[SKINCOLOR_AZURE] = "\x88",	[SKINCOLOR_AQUA] = "\x88",	[SKINCOLOR_TEAL] = "\x88",	[SKINCOLOR_CYAN] = "\x88",	[SKINCOLOR_JAWZ] = "\x88",	[SKINCOLOR_CERULEAN] = "\x88",	[SKINCOLOR_NAVY] = "\x88",	[SKINCOLOR_SAPPHIRE] = "\x88",		[SKINCOLOR_PASTEL] = "\x89",	[SKINCOLOR_MOONSLAM] = "\x89",	[SKINCOLOR_DUSK] = "\x89",	[SKINCOLOR_TOXIC] = "\x89",	[SKINCOLOR_MAUVE] = "\x89",	[SKINCOLOR_LAVENDER] = "\x89",	[SKINCOLOR_BYZANTIUM] = "\x89",	[SKINCOLOR_POMEGRANATE] = "\x89",		[SKINCOLOR_GOLD] = "\x8A",	[SKINCOLOR_ROYAL] = "\x8A",	[SKINCOLOR_BRONZE] = "\x8A",	[SKINCOLOR_COPPER] = "\x8A",	[SKINCOLOR_THUNDER] = "\x8A",		[SKINCOLOR_ARTICHOKE] = "\x8B",	[SKINCOLOR_VOMIT] = "\x8B",	[SKINCOLOR_GARDEN] = "\x8B",	[SKINCOLOR_TEA] = "\x8B",	[SKINCOLOR_PISTACHIO] = "\x8B",		[SKINCOLOR_PIGEON] = "\x8C",	[SKINCOLOR_PLATINUM] = "\x8C",	[SKINCOLOR_STEEL] = "\x8C",		[SKINCOLOR_FAIRY] = "\x8D",	[SKINCOLOR_SALMON] = "\x8D",	[SKINCOLOR_PINK] = "\x8D",	[SKINCOLOR_ROSE] = "\x8D",	[SKINCOLOR_BRICK] = "\x8D",	[SKINCOLOR_LEMONADE] = "\x8D",	[SKINCOLOR_BUBBLEGUM] = "\x8D",	[SKINCOLOR_LILAC] = "\x8D",		[SKINCOLOR_SEPIA] = "\x8E",	[SKINCOLOR_BEIGE] = "\x8E",	[SKINCOLOR_WALNUT] = "\x8E",	[SKINCOLOR_BROWN] = "\x8E",	[SKINCOLOR_LEATHER] = "\x8E",	[SKINCOLOR_RUST] = "\x8E",	[SKINCOLOR_WRISTWATCH] = "\x8E",	[SKINCOLOR_PEACH] = "\x8F",	[SKINCOLOR_CARAMEL] = "\x8F",	[SKINCOLOR_CREAM] = "\x8F",}
local starttime = 9*TICRATE + (3*TICRATE/4)

rawset(_G, "nametagactive", CV_RegisterVar({
	name = "nametag",
	defaultvalue = "On",
	flags = CV_SHOWMODIF,
	possiblevalue = CV_OnOff
}))

rawset(_G, "nametagclan", CV_RegisterVar({
	name = "nametag_clan",
	defaultvalue = "On",
	flags = CV_SHOWMODIF,
	possiblevalue = CV_OnOff
}))

rawset(_G, "nametagicon", CV_RegisterVar({
	name = "nametag_icon",
	defaultvalue = "Off",
	flags = CV_SHOWMODIF,
	possiblevalue = CV_OnOff
}))

rawset(_G, "nametagdist", CV_RegisterVar({
	name = "nametag_dist",
	defaultvalue = "320",
	flags = CV_SHOWMODIF,
	possiblevalue = {MIN = 80, MAX = 640}
}))

rawset(_G, "nametagcap", CV_RegisterVar({
	name = "nametag_cap",
	defaultvalue = "4",
	flags = CV_SHOWMODIF,
	possiblevalue = {MIN = 1, MAX = 16}
}))

rawset(_G, "nametagsmall", CV_RegisterVar({
	name = "nametag_small",
	defaultvalue = "Off",
	flags = CV_SHOWMODIF,
	possiblevalue = CV_OnOff
}))

rawset(_G, "nametagadjust", CV_RegisterVar({
	name = "nametag_adjust",
	defaultvalue = "0",
	flags = CV_SHOWMODIF,
	possiblevalue = {MIN = -160, MAX = 160}
}))

rawset(_G, "nametagtransparent", CV_RegisterVar({
	name = "nametag_trans",
	defaultvalue = "On",
	flags = CV_SHOWMODIF,
	possiblevalue = CV_OnOff
}))

local nametagdebug = CV_RegisterVar({
	name = "nametag_debug",
	defaultvalue = "Off",
	flags = CV_NOSHOWHELP|CV_SHOWMODIF,
	possiblevalue = CV_OnOff
})

local nametagstar = CV_RegisterVar({
	name = "nametag_star",
	defaultvalue = "On",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})

local nametaghpmod = CV_RegisterVar({
	name = "nametag_hp",
	defaultvalue = "On",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})

--First, we set things up
local dTags = {}
local function CanIhidemyTag(p)
	if p.kartstuff[k_hyudorotimer] 
	then return true
	else
	return false
	end
end
local function CanIkillmyTag(p)
	if p.exiting 
	or p.playerstate == PST_DEAD 
	or p.mo.health == 0 
	or p.spectator 
	or p.elim_rejoinEnd
	then return true
	else
	return false
	end
end

addHook("ThinkFrame", function()
	for player in players.iterate do
        if not player.mo or not player.mo.valid continue end 
		
		if not player.mo.taginit then
			player.mo.taginit = true
			table.insert(dTags, {
			mo = player.mo,
			owner = player.name,
			color = player.skincolor,
			score = player.score,
			clan = nil,
			hp = nil,
			visual = true
			})
		end

		for i = #dTags,1,-1 do
			local nametag = dTags[i]
			if nametag.mo and nametag.mo.valid then
				if nametag.mo == player.mo then
					--AutoUpdate
					nametag.owner = player.name
					nametag.score = player.score
					
					--Rainbow Tag go weeeee
					if player.kartstuff[k_invincibilitytimer]
						nametag.color = (1+(leveltime%(MAXSKINCOLORS-1)))
					else
						nametag.color = player.skincolor
					end
					
					--Hostmod Clan Support
					if player.HMclan 
						nametag.clan = player.HMclan 
					else
						nametag.clan = nil
					end
					
					--HpMod
					if hpmod ~= nil and hpmod.running
						nametag.hp = player.hpmod.hp
					else
						nametag.hp = nil
					end
					
					--Hide the Tag but do not remove it yet
					if CanIhidemyTag(player)
						nametag.visual = false
					else
						nametag.visual = true
					end
					
					--Now you can remove it, there's no need to keep it
					if CanIkillmyTag(player) then
						dTags[i] = 01
						table.remove(dTags, i)
					end
				end
			else
				dTags[i] = 01
				table.remove(dTags, i)
			end
		end
		
	end
end)

--Shoutout to Lat for the ScreenCoords
--With alot of edit because of god damn no-green-screen, fov, and render bullshit
local function R_GetScreenCoordsforNames(v, p, c, mx, my, mz)
	local camx, camy, camz, camangle, camaiming
	if p.awayviewtics then
		camx = p.awayviewmobj.x
		camy = p.awayviewmobj.y
		camz = p.awayviewmobj.z
		camangle = p.awayviewmobj.angle
		camaiming = p.awayviewaiming
	elseif c.chase then
		camx = c.x
		camy = c.y
		camz = c.z
		camangle = c.angle
		camaiming = c.aiming
	else
		camx = p.mo.x
		camy = p.mo.y
		camz = p.viewz-20*FRACUNIT
		camangle = p.mo.angle
		camaiming = p.aiming
	end

	local x = camangle-R_PointToAngle2(camx, camy, mx, my)
	
	local distfact = cos(x)
	if not distfact then
		distfact = 1
	end
	
	local res = (v.width()*100)/(v.height()) --Did you know that all green res give 160 on result?
	local fovplz = ((CV_FindVar("fov").value)/FRACUNIT)*res/90 --90*160/90 = 160 huehuehue
	local resfov = (res*2)-fovplz --160*2 = 320-160 = 160 HuEHuEHuE
	local adjustres = 0 --extra adjust for no-green 90fov, because FUCK
	if (res == fovplz)
		if (res < 160) --Square resolution
			adjustres = 160-res
		elseif (res > 160) --Wide Resolution
			adjustres = res-160
		end
	end
	local finalset = (resfov)+(adjustres)+(nametagadjust.value)
	--tadaa, and we add the adjust command incase some resolution doesn't work
	
	if x > ANGLE_90 or x < ANGLE_270 then
		return -9, -9, 0
	else
		x = FixedMul(tan(x, true), finalset<<FRACBITS)+160<<FRACBITS
	end

	local y = camz-mz
	y = FixedDiv(y, FixedMul(distfact, R_PointToDist2(camx, camy, mx, my)))
	y = (y*finalset)+(100<<FRACBITS)
	y = y+tan(camaiming, true)*finalset

	local scale = FixedDiv(finalset*FRACUNIT, FixedMul(distfact, R_PointToDist2(camx, camy, mx, my)))

	return x, y, scale
end

--And now the render
local function TagNames(v, player, camera)
	--Yeah i'm not gonna bother with splitscreen
	if nametagactive.value and splitscreen == 0 
	and player and player.mo and player.mo.valid 
	local tagnum = 0
		for i = #dTags,1,-1 do
			local nametag = dTags[i]
			local weighttag = table.concat(dTags, " ", 2, -1)
			if nametag.mo and nametag.mo.valid then
				local maxdist = (10*nametagdist.value)*mapobjectscale
				local thisdist = R_PointToDist(nametag.mo.x, nametag.mo.y)

				--Screw Flip Camera
				local posz = nametag.mo.z + nametag.mo.height
				if player.mo.eflags & MFE_VERTICALFLIP and not(player.pflags & PF_FLIPCAM)
					posz = nametag.mo.z - nametag.mo.height
				end
				
				local basex,basey = R_GetScreenCoordsforNames(v, player, camera, nametag.mo.x, nametag.mo.y, posz)
				if player.mo.eflags & MFE_VERTICALFLIP and not (player.pflags & PF_FLIPCAM)
					basey = $ + nametag.mo.height
				end
				
				if encoremode
					basex = 320<<FRACBITS -$
				end
				
				//local res = (v.width()*100)/(v.height())
				//local adjustnamey = 26
				//if v.renderer() == "opengl" and (CV_FindVar("gr_shearing").value)--ffs
				//	if res < 160
				//		adjustnamey = $+10
				//	elseif res > 160
				//		adjustnamey = $-5
				//	end
				//end
				
				local namex = (basex>>FRACBITS)-1
				local namey = (basey>>FRACBITS)-26		
				if player.mo.eflags & MFE_VERTICALFLIP and not (player.pflags & PF_FLIPCAM)
					namey = $-18
					namex = $+2
				end
				
				local transtag = 0
				if nametagtransparent.value
					if (thisdist > (maxdist*3/4)) or not(P_CheckSight(player.mo, nametag.mo)) --25%
						transtag = V_TRANSLUCENT
					end
				end
				
				local iconx = 0
				if nametagicon.value 
					iconx = 14
				end
			
				if (nametag.mo != player.mo and leveltime > starttime) --display Other Player tag, but first...
				or (nametag.mo == player.mo and (leveltime > 0 and leveltime < 130)) --Let's display your tag before the countdown
				or (nametagdebug.value) --Or Just display all of them because yay Debug
					if (thisdist < maxdist)
						if (nametagtransparent.value and (abs(player.mo.z - nametag.mo.z) < RING_DIST/4))
						or (not nametagtransparent.value and (abs(player.mo.z - nametag.mo.z) < RING_DIST/8))
							if nametag.visual and namex < FRACUNIT/2 and namey < FRACUNIT/2 and tagnum < nametagcap.value --plz
								tagnum = $+1
								if not nametagsmall.value 
									--Normal Size
									--Line Pointing
									if not ((player.mo.eflags & MFE_VERTICALFLIP) and not (player.pflags & PF_FLIPCAM))
										v.draw(namex, namey+10, v.cachePatch("NTLINEP"), transtag, v.getColormap(-1, nametag.color))
									else
										v.draw(namex-2, namey-3, v.cachePatch("NTLINEF"), transtag, v.getColormap(-1, nametag.color))
									end
									
									--Line Under Name
									if weighttag.len(nametag.owner) > 18
										v.draw(namex+6, namey+10, v.cachePatch("NTLINE6"), transtag, v.getColormap(-1, nametag.color))
									elseif weighttag.len(nametag.owner) > 15
										v.draw(namex+6, namey+10, v.cachePatch("NTLINE5"), transtag, v.getColormap(-1, nametag.color))
									elseif weighttag.len(nametag.owner) > 12
										v.draw(namex+6, namey+10, v.cachePatch("NTLINE4"), transtag, v.getColormap(-1, nametag.color))
									elseif weighttag.len(nametag.owner) > 9
										v.draw(namex+6, namey+10, v.cachePatch("NTLINE3"), transtag, v.getColormap(-1, nametag.color))
									elseif weighttag.len(nametag.owner) > 6
										v.draw(namex+6, namey+10, v.cachePatch("NTLINE2"), transtag, v.getColormap(-1, nametag.color))
									elseif weighttag.len(nametag.owner) > 3
										v.draw(namex+6, namey+10, v.cachePatch("NTLINE1"), transtag, v.getColormap(-1, nametag.color))
									else
										v.draw(namex+6, namey+10, v.cachePatch("NTLINE0"), transtag, v.getColormap(-1, nametag.color))
									end
									
									--Icon
									if nametagicon.value 
										v.draw(namex+4, namey-3, v.cachePatch(skins[nametag.mo.skin].facemmap), transtag, v.getColormap(nametag.mo.skin, nametag.mo.color))
									end
									
									--Name Text and Clan
									if nametagclan.value and nametag.clan
										v.drawString(iconx+namex+4, namey, "\x8C"..nametag.clan.." "..colLookup[nametag.color]..""..nametag.owner.."", transtag|V_ALLOWLOWERCASE, "thin")
									else
										v.drawString(iconx+namex+4, namey, ""..colLookup[nametag.color]..""..nametag.owner.."", transtag|V_ALLOWLOWERCASE, "thin")
									end	
									
									--HpMod
									if nametaghpmod.value and nametag.hp
										v.draw(iconx+namex+4, namey-10, v.cachePatch("NTHP"), transtag)
										v.drawString(iconx+namex+14, namey-9, "\x8D"..(nametag.hp).."", transtag, "left")
									end
									
									--Scorekeeper	
									if not nametaghpmod.value 
									or not nametag.hp 
										if nametagstar.value 
											if nametag.score >= 100000
												v.draw(iconx+namex+4, namey-9, v.cachePatch("NTCRWN"), transtag)
												v.draw(iconx+namex+20, namey-9, v.cachePatch("NTCRWN"), transtag)
												v.draw(iconx+namex+36, namey-9, v.cachePatch("NTCRWN"), transtag)
											elseif nametag.score >= 90000 
												v.draw(iconx+namex+4, namey-9, v.cachePatch("NTCRWN"), transtag)
												v.draw(iconx+namex+20, namey-9, v.cachePatch("NTCRWN"), transtag)
												v.drawString(iconx+namex+36, namey-9, "\x82***", transtag, "left")
											elseif nametag.score >= 80000 
												v.draw(iconx+namex+4, namey-9, v.cachePatch("NTCRWN"), transtag)
												v.draw(iconx+namex+20, namey-9, v.cachePatch("NTCRWN"), transtag)
												v.drawString(iconx+namex+36, namey-9, "\x82**", transtag, "left")
											elseif nametag.score >= 70000 
												v.draw(iconx+namex+4, namey-9, v.cachePatch("NTCRWN"), transtag)
												v.draw(iconx+namex+20, namey-9, v.cachePatch("NTCRWN"), transtag)
												v.drawString(iconx+namex+36, namey-9, "\x82*", transtag, "left")
											elseif nametag.score >= 60000 
												v.draw(iconx+namex+4, namey-9, v.cachePatch("NTCRWN"), transtag)
												v.draw(iconx+namex+20, namey-9, v.cachePatch("NTCRWN"), transtag)
											elseif nametag.score >= 50000 
												v.draw(iconx+namex+4, namey-9, v.cachePatch("NTCRWN"), transtag)
												v.drawString(iconx+namex+20, namey-9, "\x82***", transtag, "left")
											elseif nametag.score >= 40000
												v.draw(iconx+namex+4, namey-9, v.cachePatch("NTCRWN"), transtag)
												v.drawString(iconx+namex+20, namey-9, "\x82**", transtag, "left")
											elseif nametag.score >= 30000 
												v.draw(iconx+namex+4, namey-9, v.cachePatch("NTCRWN"), transtag)
												v.drawString(iconx+namex+20, namey-9, "\x82*", transtag, "left")
											elseif nametag.score >= 20000 
												v.draw(iconx+namex+4, namey-9, v.cachePatch("NTCRWN"), transtag)
											elseif nametag.score >= 10000 
												v.drawString(iconx+namex+4, namey-9, "\x82***", transtag, "left")
											elseif nametag.score >= 5000 
												v.drawString(iconx+namex+4, namey-9, "\x82**", transtag, "left")
											elseif nametag.score >= 1000 
												v.drawString(iconx+namex+4, namey-9, "\x82*", transtag, "left")
											end
										end
									end
								else
									--Small Size
									--Name Text and Clan
									if nametagclan.value and nametag.clan
										v.drawString(namex+5, namey+20, "\x8C"..nametag.clan.." "..colLookup[nametag.color]..""..nametag.owner.."", transtag|V_ALLOWLOWERCASE, "small")
									else
										v.drawString(namex+5, namey+20, ""..colLookup[nametag.color]..""..nametag.owner.."", transtag|V_ALLOWLOWERCASE, "small")
									end
									
									--HpMod
									if nametaghpmod.value and nametag.hp
										v.drawString(namex+5, namey+15, "\x8D"..(nametag.hp).."%", transtag, "small")
									end
									
									--Scorekeeper	
									if not nametaghpmod.value 
									or not nametag.hp 
										if nametagstar.value
											if nametag.score >= 100000
												v.drawString(namex+4, namey+15, "\x82************", transtag, "small")
											elseif nametag.score >= 90000
												v.drawString(namex+4, namey+15, "\x82***********", transtag, "small")
											elseif nametag.score >= 80000
												v.drawString(namex+4, namey+15, "\x82**********", transtag, "small")
											elseif nametag.score >= 70000
												v.drawString(namex+4, namey+15, "\x82*********", transtag, "small")
											elseif nametag.score >= 60000 
												v.drawString(namex+4, namey+15, "\x82********", transtag, "small")
											elseif nametag.score >= 50000
												v.drawString(namex+4, namey+15, "\x82*******", transtag, "small")
											elseif nametag.score >= 40000 
												v.drawString(namex+4, namey+15, "\x82******", transtag, "small")
											elseif nametag.score >= 30000
												v.drawString(namex+4, namey+15, "\x82*****", transtag, "small")
											elseif nametag.score >= 20000 
												v.drawString(namex+4, namey+15, "\x82****", transtag, "small")
											elseif nametag.score >= 10000 
												v.drawString(namex+4, namey+15, "\x82***", transtag, "small")
											elseif nametag.score >= 5000 
												v.drawString(namex+4, namey+15, "\x82**", transtag, "small")
											elseif nametag.score >= 1000 
												v.drawString(namex+4, namey+15, "\x82*", transtag, "small")
											end
										end
									end
								end
							end
						end
					end
				end
			end
		end
		if nametagdebug.value
			v.drawString(12,125, "Nametag Show: "..tagnum.."/"..nametagcap.value.."",V_ALLOWLOWERCASE|V_SNAPTOLEFT,"thin")
		end
	end
end
hud.add(TagNames)