//Sparkrate Lua
//Attempting to give a buff to the poor bastards playing at low speeds with a bonus to spark rate gain


--Added Optimization -NepDisk

--Optimization
local FRACUNIT = FRACUNIT
local k_pogospring = k_pogospring
local k_driftcharge = k_driftcharge
local k_drift = k_drift
local k_driftend = k_driftend


local sparkratelua = CV_RegisterVar({
	name = "wa_sparkrate",
	defaultvalue = "On",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})//controls on/off

local sparkratedebug = CV_RegisterVar({
	name = "wa_sparkratedebug",
	defaultvalue = "Off",
	possiblevalue = CV_OnOff
})//if you want to get spammed with tickrate notices

local sparkrate_remainder =  CV_RegisterVar({
	name = "wa_sparkrate_remainder",
	defaultvalue = 100,
	flags = CV_NETVAR,
	possiblevalue =  {MIN = 0, MAX = 100}
})

//Only controls how frequently the spark rate adders tick
//Re-enable this stuff if I want to go this route idk yet
//Addition rate is 9 - p.kartspeed
/*local tickratemin =  CV_RegisterVar({
	name = "wa_sparkratemin",
	defaultvalue = 1,
	flags = CV_NETVAR,
	possiblevalue =  {MIN = 1, MAX = 50}
})

local tickratemax =  CV_RegisterVar({
	name = "wa_sparkratemax",
	defaultvalue = 1,
	flags = CV_NETVAR,
	possiblevalue =  {MIN = 2, MAX = 50}
})*/

--Balance changelog
--7/2/23 - Increased remainder to 17 for an effective 5% rate decrease across the board

local function recalcTickRate(p)
	--y = lo ticrate + (stat total (variable) - stat min) * ((hi ticrate - lo ticrate) / (statmax - statmin))
	--Default hi ticrate 6, lo ticrate 2, statmax 18, statmin 2
	--Changed to looking at only one stat so statmax 9, statmin 1
	--I don't care if this could be condensed, adding the FRACUNIT layer made me tear my hair out
	//local statTotal = (p.kartspeed - 1)
	//local divisionstep = FixedDiv( tickratemax.value - tickratemin.value , 9 - 1 )
	//local multiplystep = FixedMul( statTotal*FRACUNIT, divisionstep )
	//local thetrunc = FixedTrunc( multiplystep )
	
	/*p.wa_s_stickrate = FixedInt( thetrunc ) + tickratemin.value
	p.wa_s_sremainder = FixedInt( (multiplystep - thetrunc) * 100 )
	p.wa_s_speedcache = p.kartspeed --This is most likely cheaper than a list because I know how bad this language is with lists.
	p.wa_s_stimeremainder = 0
	p.wa_s_sticktofire = 0*/
	
	p.wa_s_stickrate = 1
	p.wa_s_sremainder = sparkrate_remainder.value
	p.wa_s_speedcache = p.kartspeed --This is most likely cheaper than a list because I know how bad this language is with lists.
	p.wa_s_stimeremainder = 0
	p.wa_s_sticktofire = 0
	
	--Saved rate calc values instead of doing this every tick
	p.wa_s_tightrate = (13 - ((p.kartspeed * 3) / 2))
	p.wa_s_normrate = (9 - p.kartspeed)
	p.wa_s_looserate = (4 - (p.kartspeed / 2))
	--DEBUG
	if sparkratedebug.value then
		print(leveltime.. " - "..p.name .. " recalced. Tickrate ".. tostring(p.wa_s_stickrate) .. " remainder " .. tostring(p.wa_s_sremainder).." normrate "..tostring(p.wa_s_normrate))
	end
end

local function isOnGround(p)
	--Literally how they do it in source code instead of just setting a fucking flag
	if p.kartstuff[k_pogospring] then
		--'On ground' but not really for the purpose of spark rates
		return true
	elseif (p.mo.eflags & MFE_VERTICALFLIP) then
		if p.mo.z + p.mo.height >= p.mo.ceilingz then
			return true
		end
	else
		if p.mo.z <= p.mo.floorz then
			return true
		end
	end
	return false
end

addHook("ThinkFrame", function()
	if not sparkratelua.value then return end
	
	for p in players.iterate
		if p and p.valid and p.mo and not p.spectator then
			--Determine if cached values need a recalc
			if not p.wa_s_stickrate or not p.wa_s_speedcache or p.wa_s_speedcache != p.kartspeed then
				recalcTickRate(p)
			end
			
			if (not p.kartstuff[k_driftcharge] and not p.mo.k_saveddriftcharge) and p.kartstuff[k_drift] == 0 then
				if sparkratedebug.value then print(leveltime.." - Exiting due to not drifting") end
				continue --You're not even drifting, fuck off.
			end
			
			--driftsparkvalue * 4 = max, rainbow
			local cDriftSparkValue = K_GetKartDriftSparkValue(p)
			--Hard cap
			if p.kartstuff[k_driftcharge] >= cDriftSparkValue*4
				p.kartstuff[k_driftcharge] = cDriftSparkValue*4
			 end
			 
			 --First do bumpspark
			if p.mo.k_saveddriftcharge and p.kartstuff[k_driftcharge] == 0 and p.mo.eflags & MFE_JUSTBOUNCEDWALL then
				p.kartstuff[k_driftend] = 0
				p.kartstuff[k_drift] = p.mo.k_saveddrift
				p.kartstuff[k_driftcharge] = p.mo.k_saveddriftcharge //Removed bump reduction because it sucked to play
			end
			p.mo.k_saveddriftcharge = p.kartstuff[k_driftcharge]
			p.mo.k_saveddrift = p.kartstuff[k_drift]
			
			if (p.kartstuff[k_driftcharge] and p.kartstuff[k_driftcharge] >= cDriftSparkValue*4) or (not p.kartstuff[k_driftcharge] and p.wa_s_sticktofire == 0) or p.kartspeed == 9 or not isOnGround(p) then
				if sparkratedebug.value then print(leveltime.." - Exiting after bumpspark") end
				continue --Bumpspark over, you can leave too
			end
			
			if p.kartstuff[k_driftcharge] and p.wa_s_sticktofire == 0 then
				--Initalize p.wa_s_sticktofire
				p.wa_s_sticktofire = leveltime + p.wa_s_stickrate
				p.wa_s_stimeremainder = 0
				--DEBUG
				 if sparkratedebug.value then print(leveltime.." - Initialize Time "..tostring(p.wa_s_sticktofire).. " Remainder " .. tostring(p.wa_s_stimeremainder) ) end
			elseif p.kartstuff[k_driftcharge] and p.kartstuff[k_driftcharge] < cDriftSparkValue*4 and leveltime >= p.wa_s_sticktofire then
				--Rate additions based on tightness of drift
				--Loose = 9 - (p.kartspeed * 1)
				--Normal = 13 - (p.kartspeed * 1.5)
				--tight = 18 - (p.kartspeed * 2)
				
				--Ignoring inbetween driftturn for even more autistic math
				--p.kartstuff[k_drift], p.cmd.driftturn
				--Drift 5 + Driftturn 800 = tight
				--Drift 5 + Driftturn -799 = loose
				--Drift-5 + Driftturn 800 = loose
				--Drift-5 + Driftturn -799 = tight
				--Give some leeway for stick users who won't be at the extremes on every drift
				local chargeadder = 0
				
				--~30% 1 speed increase formula
				if p.kartstuff[k_drift] > 0 then
					if p.cmd.driftturn >= 700 then
						chargeadder = p.wa_s_tightrate
					elseif p.cmd.driftturn <= -699 then
						chargeadder = p.wa_s_looserate
					else
						chargeadder = p.wa_s_normrate
					end
				elseif p.kartstuff[k_drift] < 0 then
					if p.cmd.driftturn >= 700 then			
						chargeadder = p.wa_s_looserate
					elseif p.cmd.driftturn <= -699 then
						chargeadder = p.wa_s_tightrate
					else
						chargeadder = p.wa_s_normrate
					end
				end
				
				if p.drr_sparkRateAdder then --Special check for a funny mode, does nothing otherwise
					chargeadder = $ + p.drr_sparkRateAdder
				end
				
				local newvalue = p.kartstuff[k_driftcharge] + chargeadder
				if (p.kartstuff[k_driftcharge] < cDriftSparkValue*4 and newvalue >= cDriftSparkValue*4)
					or (p.kartstuff[k_driftcharge] < cDriftSparkValue*2 and newvalue >= cDriftSparkValue*2)
					or (p.kartstuff[k_driftcharge] < cDriftSparkValue and newvalue >= cDriftSparkValue) then
					--Need to manually play the spark charge sound effect because the game won't do it
					if sparkratedebug.value then print(leveltime.." - Triggered lua sound play") end
					S_StartSoundAtVolume(p.mo, sfx_s3ka2, 192);
				end
				p.kartstuff[k_driftcharge] = newvalue
				
				p.wa_s_stimeremainder = $ + p.wa_s_sremainder --Increment remainder counter				
							
				local tickdelay = FixedInt( FixedTrunc( FixedDiv( p.wa_s_stimeremainder , 100 ) ) )--If remainder is > 100, then calculate how much to delay the next tick
				p.wa_s_stimeremainder = p.wa_s_stimeremainder % 100 --Clear counter of the 100's place since it was factored in		
				
				--Set the next tick to fire on
				p.wa_s_sticktofire = leveltime + p.wa_s_stickrate + tickdelay
				
				--DEBUG
				if sparkratedebug.value then print(tostring(leveltime) .. " - Ticked up by " .. tostring(chargeadder) .."("..tostring(p.wa_s_stickrate).."."..tostring(p.wa_s_sremainder)..") Current Remainder ".. tostring(p.wa_s_stimeremainder) .. " Next Tic " .. tostring(p.wa_s_sticktofire) ) end
			elseif not p.kartstuff[k_driftcharge] and p.wa_s_sticktofire != 0 then
				--Clean up
				p.wa_s_sticktofire = 0
				p.wa_s_stimeremainder = 0
				
				--DEBUG
				if sparkratedebug.value then print(leveltime.." - Spark timers reset") end
			end
			
			//print(p.name.."; spinout: "..p.kartstuff[k_spinouttimer]..", wipeout: "..p.kartstuff[k_wipeoutslow])
		end
	end
end)